;***************************************************************************
; This demo form contains three buttons performing simple acts.  Using 
;      getevent to trap the row and col of the mouse down allows you to
;      to evaluate which button was chosen.  I chose placing the buttons
;      on the form rather than displaying a dialog box for data entry
;      (as reported in PI May93) because of the extensive form I already
;      had in place.  However, using getevent is not as simple as using
;      wait.  I want to gradually get my users into the windows GUI 
;      environment without scaring them to death.  The buttons can be more
;      "windows-looking" but I chose (for consistency) to make them look
;      and feel like Paradox Dos buttons.  You can also set up hot keys by
;      trapping for that button's alt key combo.  Hope this works for you.
;***************************************************************************

btnlib = "BTNLIB"
CREATELIB btnlib
AutoLib = "BTNLIB"

;***************************************************************************
; This proc creates a two canvas windows to be displayed over the button on 
;      the form.  The GrayBox covers the existing button and the DepressBtn
;      simulates the look of a button that has been pushed.  Sleep 200 and 
;      close the window.  The arguments this proc takes are:
;                       t = text in quotes(must include spaces)
;                       r = top left hand row of button
;                       c = starting column number of button
;***************************************************************************

PROC DepressBtn(t,r,c)

DYNARRAY SetGrayBox[]
SetGrayBox["FLOATING"] = True
SetGrayBox["HASFRAME"] = False
SetGrayBox["HASSHADOW"] = False
SetGrayBox["ORIGINROW"] = r
SetGrayBox["ORIGINCOL"] = c-1
SetGrayBox["HEIGHT"] = 2
SetGrayBox["WIDTH"] = 11
SetGrayBox["STYLE"] = 119

DYNARRAY SetDepressBtn[]

SetDepressBtn["FLOATING"] = True
SetDepressBtn["HASFRAME"] = False
SetDepressBtn["HASSHADOW"] = False
SetDepressBtn["ORIGINROW"] = r
SetDepressBtn["ORIGINCOL"] = c
SetDepressBtn["HEIGHT"] = 1
SetDepressBtn["WIDTH"] = 10
SetDepressBtn["STYLE"] = 47
SetDepressBtn["CANVAS"] = True
SetDepressBtn["CANVASHEIGHT"] = 1
SetDepressBtn["CANVASWIDTH"] = 11

ECHO OFF
WINDOW CREATE ATTRIBUTES SetGrayBox TO GrayBox
WINDOW CREATE ATTRIBUTES SetDepressBtn TO DepressBtn
WINDOW SELECT DepressBtn
@ 0,1 ??t
ECHO NORMAL
SLEEP 200
ECHO OFF
WINDOW SELECT DepressBtn
WINDOW CLOSE
WINDOW SELECT GrayBox
WINDOW CLOSE
ECHO NORMAL

ENDPROC
WRITELIB btnlib DepressBtn
RELEASE PROCS DepressBtn

;***************************************************************************
; Coedit table and setup display parameters.
;***************************************************************************
coedit "cust"
window handle current to tablewin
window move tablewin to 500,500
formkey
window handle form to formwin

dynarray main[]
main["height"] = 15
main["width"] = 66
main["originrow"] = 3
main["origincol"] = 6
main["hasframe"] = false
main["hasshadow"] = false

window setattributes formwin from main

PROMPT " Use the buttons to scroll through the records.  CANCEL to quit demo."
SHOWPULLDOWN
ENDMENU
ECHO NORMAL

WHILE true
GETEVENT MOUSE "DOWN" TO EventArray

;***************************************************************************
; Use the following messages to determine the locations of your buttons.  
;     make sure to have your form window designed exactly the way you want
;     it.  Then run this code and mouse clice on the far left and far right
;     corners of your buttons.  Write down the numbers for use in your
;     SWITCH-CASE statement below.
;***************************************************************************

;MESSAGE "ROW = " + STRVAL(EventArray["ROW"])
;SLEEP 3000
;MESSAGE "COL = " + STRVAL(EventArray["COL"])
;SLEEP 3000

SWITCH
;***************************************************************************
;  The following checks to see if the mouse click occurred on the button.
;      insert the correct row #.  Subtract 1 from the beginning column #
;      and add 1 to the ending column # (to catch ALL clicks on the button).
;      Call the DepressBtn proc.  The arguments are:  text (exactly including
;      spaces...but the proc assumes you have at least one space), row 
;      number, and beginning column # plus 1 (to add depth to the button).
;      Then execute your action.  I have several procs called by similar
;      buttons on my main data entry form.
;***************************************************************************

   CASE EventArray["ROW"] = 14 AND EventArray["COL"] > 12 AND EventArray["COL"] < 23 :
        DepressBtn("Next rec",14,14)
        PGDN
   CASE EventArray["ROW"] = 14 AND EventArray["COL"] > 29 AND EventArray["COL"] < 40 :
        DepressBtn("Prev rec",14,31)
        PGUP
   CASE EventArray["ROW"] = 14 AND EventArray["COL"] > 45 AND EventArray["COL"] < 56 :
        DepressBtn(" Cancel",14,47)
        QUITLOOP
   OTHERWISE : EXECEVENT EventArray
               LOOP
ENDSWITCH
ENDWHILE
DO_IT!
CLEARALL               